#****************************************************************************#
#SeSiMCMC. Looking - for - motifs by MCMC project. (c) A. Favorov 2001
#$Id: gibbslfm.mak 1034 2009-04-17 14:07:27Z favorov $
#****************************************************************************#


exename=Binner
od=./obj

srcdirlist=.

empty=
space=$(empty) $(empty)
includeflags = $(foreach dir,$(subst :,$(space),$(srcdirlist)),$(INCLUDEKEY)$(dir)) $(INCLUDECLOSETERM)
#this strange invocation is just preparing -I flag from srcdirlist.

OPTIMISE=YES

include ccvars

.PHONY: all objs clean

vpath %.c $(srcdirlist)
vpath %.cpp $(srcdirlist)

all: $(exename)$(EXEEXT) 

OBJS=\
	$(od)/binning.o \
	$(od)/bTrack.o \
	$(od)/data.o \
	$(od)/formula.o \
	$(od)/FourierCorr.o \
	$(od)/householder.o \
	$(od)/kernel.o \
	$(od)/mann.o \
	$(od)/map.o \
	$(od)/mixfft.o \
	$(od)/out.o \
	$(od)/outLC.o \
	$(od)/parsePrm.o \
	$(od)/sg_utils.o \
	$(od)/trackPrepare.o \
	$(od)/util.o \

	
objs:$(OBJS)

$(od)/%.o: %.c
	$(CC) $(CCFLAGS) $< -o $@
	
$(od)/%.o: %.cpp
	$(CPP) $(CPPFLAGS) $< -o $@

$(exename)$(EXEEXT): $(OBJS)
	$(CPP) -o $(exename)$(EXEEXT) $(OBJS) $(LINKFLAGS)
	chmod 755 $(exename)$(EXEEXT) 

#generated by g++ -MM *.c*
$(od)/binning.o:          binning.cpp          sg_util.h track_util.h util.h
$(od)/bTrack.o:           bTrack.cpp           sg_util.h track_util.h util.h
$(od)/data.o:             data.cpp             sg_util.h track_util.h util.h
$(od)/formula.o:          formula.cpp          sg_util.h track_util.h util.h
$(od)/FourierCorr.o:      FourierCorr.cpp      sg_util.h track_util.h util.h
$(od)/householder.o:      householder.cpp      sg_util.h track_util.h util.h
$(od)/kernel.o:           kernel.cpp           sg_util.h track_util.h util.h
$(od)/mann.o:             mann.cpp             sg_util.h track_util.h util.h
$(od)/map.o:              map.cpp              sg_util.h track_util.h util.h
$(od)/mixfft.o: mixfft.c
$(od)/out.o:              out.cpp              sg_util.h track_util.h util.h
$(od)/outLC.o:             outLC.cpp            sg_util.h track_util.h util.h
$(od)/parsePrm.o:          parsePrm.cpp         sg_util.h track_util.h util.h
$(od)/sg_utils.o:          sg_utils.cpp         sg_util.h track_util.h util.h
$(od)/trackPrepare.o:      trackPrepare.cpp     sg_util.h track_util.h util.h
$(od)/util.o:              util.cpp             sg_util.h track_util.h util.h

clean:
	rm -f $(OBJS)
	rm -r -f *~
